// guiManager.cpp

#include "game.h"

/*
=====================================================
void guiManager::DrawText(char *text, int x, int y)
=====================================================
*/

void guiManager::DrawText(char *text, int fontTile, int x, int y)
{
	int startFont = fontTile;
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*10))<<16,y<<16,65536L,0,charTile,16,0,10,0,0,800-1,600-1);
	}
}

/*
=====================================================
void guiManager::DrawTextNoFlash(char *text, int x, int y)
=====================================================
*/

void guiManager::DrawTextNoFlash(char *text, int x, int y)
{
	int startFont = 4257;
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*10))<<16,y<<16,65536L,0,charTile,1,0,10,0,0,800-1,600-1);
	}
}

/*
===========================================================
void guiManager::DrawTextLight(char *text, int fontTile, int x, int y)
===========================================================
*/
void guiManager::DrawTextLight(char *text, int fontTile, int x, int y)
{
	int startFont = fontTile;//= 4257;
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*10))<<16,y<<16,65536L,0,charTile,((6+(build_func->ftotalclock()>>2))%13),0,10,0,0,800-1,600-1);
	}
}

/*
=====================================================
void guiManager::DrawText(char *text, int x, int y)
=====================================================
*/

void guiManager::DrawTextCustom(char *text, long startFont, int shade, int x, int y)
{
	int i = 0;
	int charTile  = -1;
	int startChar = 48;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*10))<<16,y<<16,65536L,0,charTile,shade,0,10,0,0,800-1,600-1);
	}
}

/*
=====================================================
void guiManager::DrawText(char *text, int x, int y)
=====================================================
*/

void guiManager::DrawTextCustom2(char *text, long startFont, int shade, int x, int y)
{
	int i = 0;
	int charTile  = -1;
	int startChar = 97;
	
	for(i = 0; i < strlen(text); i++)
	{
		charTile = startFont + (text[i] - startChar);
		build_func->rotatesprite((x + (i*10))<<16,y<<16,65536L,0,charTile,shade,0,10,0,0,800-1,600-1);
	}
}

/*
DrawTile

Draws a tile on the screen
*/

void guiManager::DrawTile(int tilenum, int x, int y, int width, int height)
{
	build_func->rotatesprite(width<<15,height<<15,65536L,0,tilenum,0,0,2+8+64,0,0,800-1,600-1);
}

/*
DrawFullHud

Draws the hud to the screen, which needs to be done special
*/
void guiManager::DrawFullHud(long x1,long y1,long x2,long y2)
{
	//build_func->rotatesprite(0,(200-34)<<16,65536L,0,STATUSBAR,0,0,2+8+64,build_func->scale(x1,xdim,320),build_func->scale(y1,ydim,200),build_func->scale(x2,xdim,320),build_func->scale(y2,ydim,200)-1);
}



/*
void guiManager::PrepareGUI(void)

Prepares the 2D gui
*/
void guiManager::PrepareGUI(void)
{
	build_func->nextpage();
	build_func->clearview(0L);
}
/*
void guiManager::2DInit(void)

Starts the 2D gui system
*/
void guiManager::Init2D(void)
{
	this->PrepareGUI();
}

/*
void guiManager::DrawLoading(char *board))

Draws a loading screen
*/
void guiManager::DrawLoading(char *board)
{
	this->DrawTile(MENUBK,0,0,320,200);
}